require "core"
require "wowdb_maps"
require "wowdb_recipes"
require "wowdb_pets_and_mounts"
class Test
  include JsonHelper
  def doit(d)
    from_json(d)
  end
end

$testmaps = false
$testrecipes = false
$testpets = true
$testdbc = false
d = Test.new()


if $testmaps
# Azermist isle mape data
f = File::open("wowdb-mapdata.txt")
m = f.read()
tbl = d.doit(m)
puts tbl[0][:mapLabel]
end

# Elixir of wisdom
if $testrecipes
r = File.open("recipe-list.txt")
n = r.read()
mbl = d.doit(n)
puts "#{mbl[20].inspect}"
end
# For RIGHT NOW not adding the dbc parser till can be discussed.
# require "dbc_file"
# test DBCFile and generate width,height for Silithus
# NOTE: test requires you to adjust the path to the dbc file, as this is copyright blizz and not
# able to check it into src control
if $testdbc
require "dbc_file"
d = DBCFile.new("/Users/washu/Downloads/WorldMapArea-2.dbc","iiisffffI")
r = d.get_record(40)
puts "#{r[3]} = {#{(r[5].to_f - r[4].to_f).abs},#{(r[7].to_f-r[6].to_f).abs}},"
end
# test wowdb map base class, handles herbs, minerals, pickable chest, normla containers, fish schools
# as list of name ot wowdb ID
if $testmaps
nodes = WoWDBMaps.new
results = nodes.get_map_locations(1617)
puts results["Westfall"].inspect
end

if $testrecipes
recipes = WoWDBRecipes.new
results = recipes.get_blacksmithing_list
thunder = results['Thunder']
recipes.add_recipe_details(thunder)

pots = recipes.get_alchemy_list
pots.each_pair do |name,data|
  source, trainerflag = "Unknown", "nil" 
  source, trainerflag = 'L["Trainer"]', 1 unless data[:method_vendors].nil? 
  skill = "0"
  unless data[:skillup].nil?
    skill = data[:skillup].first
  end
  $stdout.puts "%Q|self:addTradeSkillSpell(#{data[:id]}, #{skill}, #{source}, #{trainerflag})|"
end
#pots.each_pair do |k,v|
#  puts k
#end
#dream = pots['Transmute: Iron to Gold']
#recipes.add_recipe_details(dream)
#puts dream.inspect
end

if $testpets
  list = WoWDBPetsAndMounts.new
  pets = list.get_pet_list
  pets.each_pair do |name,data|
    puts "Pet: #{name}"
  end
  mounts = list.get_mount_list
  data = mounts['Reins of the Veridian Netherwing Drake']
  #mounts.each_pair do |name,data|
  list.add_mount_details(data)
  puts "Mount: #{data.inspect}"
  source, trainerflag = 'L["Trainer"]', data[:method_vendors].nil?() ? 1 : 0
  puts "#{source}, #{trainerflag}"
  questonly = mounts['Black Qiraji Resonating Crystal']
  list.add_mount_details(questonly)
  puts "Mount: #{questonly.inspect}"
  #end
end